import 'package:intl/date_symbol_data_local.dart';
import 'package:intl/intl.dart';

class Date {
  static String parseAndFormat(String date, {formatFrom = 'yyyy-MM-dd HH:mm:ss', formatTo = 'yyyy-MM-dd HH:mm:ss', locale = 'id_ID'}) {
    DateTime dateTime = parse(date, format: formatFrom, locale: locale);
    return format(dateTime, format: formatTo, locale: locale);
  }

  static String format(DateTime dateTime, {format = 'yyyy-MM-dd HH:mm:ss', locale = 'id_ID'}) {
    initializeDateFormatting(locale);
    return DateFormat(format, locale).format(dateTime);
  }

  static DateTime parse(String date, {format = 'yyyy-MM-dd HH:mm:ss', locale = 'id_ID'}) {
    return DateFormat(format, locale).parse(date);
  }
}