import 'dart:io';

import 'package:http/http.dart' as http;
import 'package:http/http.dart';
import 'package:http_parser/http_parser.dart';
import 'package:mime_type/mime_type.dart';

class ApiMultipartRequest {
  static ApiMultipartRequest? _apiMultipartRequest;
  static MultipartRequest? _multipartRequest;
  static Uri? _uri;
  static String? _apiMethod;
  final fields = <String, String>{};
  final List<http.MultipartFile> files = [];

  ApiMultipartRequest._createInstance();

  MultipartRequest get request {
    _multipartRequest = initialize();
    return _multipartRequest!;
  }

  factory ApiMultipartRequest(Uri uri, String method) {
    if (_apiMethod == null) {
      _apiMethod = method;
    }
    if (_uri == null) {
      _uri = uri;
    }
    _apiMultipartRequest = ApiMultipartRequest._createInstance();
    return _apiMultipartRequest!;
  }

  MultipartRequest initialize() {
    var request = new http.MultipartRequest(_apiMethod ?? '', _uri ?? Uri());
    return request;
  }

  add(String name, String value) {
    fields['$name'] = '$value';
  }

  Future<MultipartFile> addFiles(String name, File file) async {
    var type = mime(file.path);
    var types = type?.split('/');
    var result;
    if (types != null && types.length >= 2) {
      result = await http.MultipartFile.fromPath('$name', '${file.path}', contentType: MediaType(types[0], types[1]));
      files.add(result);
    } else {
      result = await http.MultipartFile.fromPath('$name', '${file.path}');
      files.add(result);
    }
    return result;
  }

  MultipartRequest getRequest() {
    var request = this.request;
    if (fields.length > 0) {
      fields.forEach((name, value) {
        request.fields['$name'] = '$value';
      });
    }

    if (files.length > 0) {
      request.files.addAll(files);
    }
    return request;
  }
}

class ApiMethod {
  static String post = 'POST';
  static String put = 'PUT';
}
