import 'package:intl/intl.dart';
import 'package:xutils/string/string_extension.dart';

class Number {
  static String? defaultCurrency;
  static String? defaultCurrencySymbol;
  static String? defaultDecimalPattern;
  static int? defaultDecimalDigits;

  static String formatCurrency(double amount, {String currency = 'id_IDR', symbol, decimalPattern = 'id_ID', digits = 2}) {
    final money = NumberFormat.currency(
      locale: defaultCurrency ?? currency,
      symbol: defaultCurrencySymbol ?? symbol,
      decimalDigits: defaultDecimalDigits ?? digits,
    );
    String a = '';
    a.capitalizeFirstLetter;
    return '${money.format(amount)}';
  }

  static double unFormatCurrency(String amount, {String currency = 'id_IDR', symbol, decimalPattern = 'id_ID', digits = 2}) {
    final money = NumberFormat.currency(
      locale: defaultCurrency ?? currency,
      symbol: defaultCurrencySymbol ?? symbol,
      decimalDigits: defaultDecimalDigits ?? digits,
    );
    // money.parse(amount);
    return money.parse(amount).toDouble();
  }

  static String formatNumber(double number, {decimalPattern = 'id_ID'}) {
    final f = new NumberFormat.decimalPattern(defaultDecimalPattern ?? decimalPattern);
    return f.format(number);
  }

  static String formatPercent(double number, {decimalPattern = 'id_ID'}) {
    final f = new NumberFormat.decimalPercentPattern(locale: defaultDecimalPattern ?? decimalPattern, decimalDigits: defaultDecimalDigits);
    return f.format(number);
  }
}
