import 'package:flutter/material.dart';
import 'package:flutter/services.dart';

import 'number.dart';

class CurrencyInputFormatter extends TextInputFormatter {
  TextEditingValue formatEditUpdate(TextEditingValue oldValue, TextEditingValue newValue) {
    if (newValue.selection.baseOffset == 0) {
      return newValue;
    }

    String newText = '${Number.formatCurrency(Number.unFormatCurrency(newValue.text))}';

    return newValue.copyWith(text: newText, selection: new TextSelection.collapsed(offset: newText.length));
  }
}

class NumberInputFormatter extends TextInputFormatter {
  TextEditingValue formatEditUpdate(TextEditingValue oldValue, TextEditingValue newValue) {
    if (newValue.selection.baseOffset == 0) {
      return newValue;
    }

    String newText = "${Number.formatNumber(double.parse(newValue.text))}";

    return newValue.copyWith(text: newText, selection: new TextSelection.collapsed(offset: newText.length));
  }
}
