import 'package:hive/hive.dart';
import 'package:hive_flutter/hive_flutter.dart';

class Hives {
  static String _boxKey = 'ROOTad_key';

  static LazyBox? _box;

  static init() async {
    await Hive.initFlutter();
  }

  static openBox({String? boxKey}) async {
    _boxKey = boxKey ?? _boxKey;
    _box = await Hive.openLazyBox(_boxKey);
  }

  static dynamic get(String key, {dynamic defaultValue}) {
    if (_box == null) openBox();
    return _box?.get(key, defaultValue: defaultValue);
  }

  static Future<void> put(String key, dynamic value) async {
    if (_box == null) openBox();
    await _box?.put(key, value);
  }

  static Future<void> putAll(Map<dynamic, dynamic> value) async {
    if (_box == null) openBox();
    await _box?.putAll(value);
  }

  static Future<bool> unset(String key) async {
    if (_box == null) openBox();
    if (_box?.containsKey(key) ?? false) {
      await _box?.delete(key);
      return true;
    }
    return false;
  }
}
