import 'package:shared_preferences/shared_preferences.dart';

class Shared {
  static SharedPreferences? _prefs;

  static init() async {
    _prefs = await SharedPreferences.getInstance();
  }

  static Future<dynamic?> get<T>(String key) async {
    if (_prefs == null) await init();
    if (_prefs?.containsKey(key) ?? false) {
      return _prefs?.get(key);
    } else {
      return null;
    }
  }

  static Future<bool> putDouble(String key, double value) async {
    if (_prefs == null) await init();
    return await _prefs?.setDouble(key, value) ?? false;
  }

  static Future<bool> putInt(String key, int value) async {
    if (_prefs == null) await init();
    return await _prefs?.setInt(key, value) ?? false;
  }

  static Future<bool> putBool(String key, bool value) async {
    if (_prefs == null) await init();
    return await _prefs?.setBool(key, value) ?? false;
  }

  static Future<bool> putString(String key, String value) async {
    if (_prefs == null) await init();
    return await _prefs?.setString(key, value) ?? false;
  }

  static Future<bool> remove(String key) async {
    if (_prefs == null) await init();
    if (_prefs?.containsKey(key) ?? false) {
      return await _prefs?.remove(key) ?? false;
    } else {
      return false;
    }
  }

  static Future<bool> clear() async {
    if (_prefs == null) await init();
    return await _prefs?.clear() ?? false;
  }
}
